// Emacs style mode select   -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id: i_tcp.c,v 1.39 2003/05/04 02:31:53 sburke Exp $
//
// Copyright (C) 1998-2000 by DooM Legacy Team.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
//
// $Log: i_tcp.c,v $

// DESCRIPTION:
// NOTE:  Only symbian 32 here
//
//-----------------------------------------------------------------------------

#include <e32std.h>
#include <btdevice.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <in_sock.h>
#include <sys/time.h>
#include <netdb_r.h>
#include <es_sock.h>
#include <bt_sock.h>
typedef struct {
	TInetAddr ip;
	TBTSockAddr  bt;
}  mysockaddr_t;



class TDoomSocket
{
public:
	TBool iSocketConnected;
	RSocket iSocket;
	TInetAddr iAddress;
	TBTSockAddr iBTAddress;
};


#include <QBTselectdlg.h> 

class CTCPHelperClass:public CBase
{
public:
	static CTCPHelperClass* NewL()
	{
		CTCPHelperClass* self = new (ELeave) CTCPHelperClass;
		CleanupStack::PushL(self);
		self->ConstructL();
		CleanupStack::Pop(self);
		return self;
	}

	~CTCPHelperClass()
	{
		delete iBTDevice;
		iHostResolver.Close();
		iSockServ.Close();
	}

	TInt GetHostByName(char* aHostAddress, TInetAddr& anAddr)
	{
		TInt error = KErrNotFound;
		TNameEntry result;
		TPtrC8 ptr((unsigned char*) aHostAddress, strlen(aHostAddress));
		HBufC* hostName = HBufC::NewLC(ptr.Length());
		hostName->Des().Copy(ptr);
		error = iHostResolver.GetByName(*hostName, result);

		if(error == KErrNone)
		{
			anAddr.SetAddress(TInetAddr::Cast(result().iAddr).Address());
		}

		CleanupStack::PopAndDestroy(hostName);
		return error;
	}

	RSocketServ& SockServ(){ return iSockServ;}

	TBool SelectBluetoothDeviceL()
	{
		TBool result = EFalse;
		CBTDeviceArray* selectedArray = new (ELeave) CBTDeviceArray(5);
		CleanupStack::PushL(selectedArray);
		CQBTUISelectDialog* selectDlg = CQBTUISelectDialog::NewL(selectedArray);
		TInt res = selectDlg->LaunchSingleSelectDialogLD();
		if(selectedArray->Count()>0)
		{
			delete iBTDevice;
			iBTDevice = NULL;
			iBTDevice = selectedArray->At(0)->CopyL();
			result = ETrue;
		}
		CleanupStack::PopAndDestroy(selectedArray);
		return result;
	}

protected:

	void ConstructL()
	{
		iSockServ.Connect();
		TInt error = iHostResolver.Open(iSockServ, KAfInet, KProtocolInetUdp);
		error = error;
	}

	CTCPHelperClass()
	{
	}

private:
	RSocketServ iSockServ;
	RHostResolver iHostResolver;
	CBTDevice* iBTDevice;

};
CTCPHelperClass* gHelperClass;
extern "C"
{
#include "doomdef.h"
#include "i_system.h"
#include "i_net.h"
#include "d_net.h"
#include "m_argv.h"
#include "command.h"
#include "d_main.h"

#include "doomstat.h"
#include "mserv.h" //Hurdler: support master server

#define IPPORT_USERRESERVED 5000


static mysockaddr_t clientaddress[MAXNETNODES+1];
        
static TDoomSocket   mysocket;
static boolean  nodeconnected[MAXNETNODES+1];
static boolean  bluetooth;
int sock_port = (IPPORT_USERRESERVED +0x1d );  // 5029

char *SOCK_AddrToStr(mysockaddr_t *sk)
{
    static char s[50];
	TPtr8 ptr((unsigned char*) s, 0, 49);
	TBuf<50> output;

	if(bluetooth)
	{
		sk->bt.BTAddr().GetReadable(output);
	}
	else
	{
		sk->ip.Output(output);
	}

	ptr.Copy(output);
	ptr.PtrZ();
	return s;
}


boolean BT_cmpaddr(mysockaddr_t *a,mysockaddr_t *b)
{
	return a->bt == b->bt;
}

boolean UDP_cmpaddr(mysockaddr_t *a,mysockaddr_t *b)
{
	// compare addresses
	return a->ip == b->ip;
}

boolean (*SOCK_cmpaddr) (mysockaddr_t *a,mysockaddr_t *b);


static int getfreenode( void )
{
    int j;

    for(j=0;j<MAXNETNODES;j++)
        if( !nodeconnected[j] )
        {
            nodeconnected[j]=true;
            return j;
        }
    return -1;
}

//Hurdler: something is wrong with Robert's patch and win2k
void SOCK_Get(void)
{
    int           i,j,c;
    mysockaddr_t  fromaddress;
	if(mysocket.iSocketConnected)
	{
		TPtr8 ptr((unsigned char *)&doomcom->data, 0, MAXPACKETLENGTH);
		TRequestStatus status = KRequestPending;
		mysocket.iSocket.RecvFrom(ptr, fromaddress.ip, 0, status);
		User::WaitForRequest(status);
		c = status.Int();
		
		if (c != KErrNone )
		{
			if ( 
				(c==KErrWouldBlock) || 
				(c==KErrTooBig)    
				/*||(c==ECONNREFUSED)*/ )
			{
				doomcom->remotenode = -1;      // no packet
				return;
			}
			I_Error ("SOCK_Get: %d", c);
		}
		else
		{
			c = ptr.Length();
		}
		//    DEBFILE(va("Get from %s\n",SOCK_AddrToStr(&fromaddress)));
		
		// find remote node number
		for (i=0 ; i<MAXNETNODES ; i++)
			if ( SOCK_cmpaddr(&fromaddress,&(clientaddress[i])) )
			{
				doomcom->remotenode = i;      // good packet from a game player
				doomcom->datalength = c;
				return;
			}
			
			// not found
			// find a free slot
			j=getfreenode();
			if(j>0)
			{
				clientaddress[j].ip = fromaddress.ip;
#ifdef DEBUGFILE
				if( debugfile )
					fprintf(debugfile,"New node detected : node:%d address:%s\n",j,SOCK_AddrToStr(&clientaddress[j]));
#endif
				doomcom->remotenode = j; // good packet from a game player
				doomcom->datalength = c;
				return;
			}
			
			// node table full
			if( debugfile )
				fprintf(debugfile,"New node detected : No more free slote\n");
	}
    doomcom->remotenode = -1;               // no packet
}

fd_set set;

// check if we can send (do not go over the buffer)
boolean SOCK_CanSend(void)
{
	//static struct timeval timeval_for_select={0,0};
    // huh Boris, are you sure about the 1th argument:
    // it is the highest-numbered descriptor in any of the three
    // sets, plus 1 (I suppose mysocket + 1).
    // BP:ok, no prob since it is ignored in windows :)
//    return select(mysocket + 1,NULL,&set,NULL,&timeval_for_select);
	return false;
}

void SOCK_Send(void)
{
    int         c;
                         
    if( !nodeconnected[doomcom->remotenode] )
        return;
	TRequestStatus status = KRequestPending;
	TPtrC8 ptr((unsigned char*) &doomcom->data, doomcom->datalength);
	mysocket.iSocket.SendTo(ptr, clientaddress[doomcom->remotenode].ip, 0, status);
	User::WaitForRequest(status);
	c = status.Int();
  /*  c = sendto (mysocket , (char *)&doomcom->data, doomcom->datalength
                ,0,(struct sockaddr *)&clientaddress[doomcom->remotenode]
                ,sizeof(struct sockaddr));*/

//    DEBFILE(va("send to %s\n",SOCK_AddrToStr(&clientaddress[doomcom->remotenode])));
    // ECONNREFUSED was send by linux port
    if (c != KErrNone && c != KErrWouldBlock) 
       I_Error ("SOCK_Send sending to node %d (%s): %d",doomcom->remotenode,SOCK_AddrToStr(&clientaddress[doomcom->remotenode]), c);
}

void SOCK_FreeNodenum(int numnode)
{
    // can't disconnect to self :)
    if(!numnode)
        return;

    if( debugfile )
        fprintf(debugfile,"Free node %d (%s)\n",numnode,SOCK_AddrToStr(&clientaddress[numnode]));

    nodeconnected[numnode]=false;

    // put invalide address
	clientaddress[numnode].ip.SetAddress(KInetAddrAny);
}

//
// UDPsocket
//
TDoomSocket UDP_Socket (void)
{
    TDoomSocket udpsocket;
	
    //struct sockaddr_in  address;
    int i;

    // allocate a socket
	TInt error = udpsocket.iSocket.Open(gHelperClass->SockServ(), KAfInet, KSockDatagram, KProtocolInetUdp);

    if (error != KErrNone)
        I_Error ("Udp_socket: Can't create socket: %d", error);
	else
		udpsocket.iSocketConnected = ETrue;
		
	udpsocket.iAddress.SetFamily(KAfInet);
	udpsocket.iAddress.SetAddress(KInetAddrAny);
    
    //Hurdler: I'd like to put a server and a client on the same computer
    //BP: in fact for client we can use any free port we want i have read 
    //    in some doc that connect in udp can do it for us...
    if ( (i = M_CheckParm ("-clientport"))!=0 )
    {
        if( !M_IsNextParm() )
            I_Error("syntax : -clientport <portnum>");
		udpsocket.iAddress.SetPort( atoi(M_GetNextParm()));
    }
    else
		udpsocket.iAddress.SetPort( sock_port);

	error = udpsocket.iSocket.Bind(udpsocket.iAddress);
	if(error != KErrNone)
        I_Error ("UDP_Bind: %d", error);

    // make it non blocking
	TInt nonBlocking = 1;
	error = udpsocket.iSocket.SetOpt(KSONonBlockingIO, KSOLSocket, nonBlocking);
    // make it broadcastable
    //setsockopt(s, SOL_SOCKET, SO_BROADCAST, (char *)&trueval, sizeof(trueval));
	//error = s.iSocket.SetOpt(KSOLSocket, KSONonBlockingIO, nonBlocking);

	error = udpsocket.iSocket.GetOpt(KSolInetIp , KSORecvBuf, i);

	i = 65536;
    CONS_Printf("Network system buffer : %dKb\n",i>>10);

    if(i < 64<<10) // 64k
    {
        i=64<<10;
		error = udpsocket.iSocket.SetOpt(KSORecvBuf, KSOLSocket, i);
//        if( setsockopt(s, SOL_SOCKET, SO_RCVBUF, (char *)&i, sizeof(i))!=0 )
		if(error != KErrNone)
            CONS_Printf("Can't set buffer length to 64k, file transfer will be bad\n");
        else
            CONS_Printf("Network system buffer set to : %d\n",i);
    }

    // ip + udp
    packetheaderlength=20 + 8; // for stats

    clientaddress[0].ip.SetFamily(KAfInet);//      = AF_INET;
    clientaddress[0].ip.SetPort(sock_port);//ip.sin_port        = htons(sock_port);
    clientaddress[0].ip.SetAddress(KInetAddrLoop);//sin_addr.s_addr = INADDR_LOOPBACK; //GetLocalAddress(); // my own ip
                                      // inet_addr("127.0.0.1");
    // setup broadcast adress to BROADCASTADDR entry
    clientaddress[BROADCASTADDR].ip.SetFamily(KAfInet);//sin_family      = AF_INET;
    clientaddress[BROADCASTADDR].ip.SetPort(sock_port);//sin_port        = htons(sock_port);
    clientaddress[BROADCASTADDR].ip.SetAddress(KInetAddrBroadcast);//sin_addr.s_addr = INADDR_BROADCAST;

    doomcom->extratics=1; // internet is very high ping

    SOCK_cmpaddr=UDP_cmpaddr;
    return udpsocket;
}

TDoomSocket BT_Socket (void)
{
    TDoomSocket btsocket;

    int i;

    // allocate a socket
	TInt error = btsocket.iSocket.Open(gHelperClass->SockServ(), KBTAddrFamily, KSockSeqPacket, KL2CAP);

    if (error != KErrNone)
        I_Error ("BT_socket: Can't create socket: %d", error);
	else
		btsocket.iSocketConnected = ETrue;
	btsocket.iBTAddress.SetFamily(KBTAddrFamily);
	btsocket.iBTAddress.SetBTAddr(KInetAddrAny);
	btsocket.iBTAddress.SetPort(sock_port);
	error = btsocket.iSocket.Bind(btsocket.iBTAddress);


   // if (bind (s, (struct sockaddr *)&address, sizeof(address)) == -1)
     //   I_Error ("IPX_Bind: %s", strerror(errno));

    // make it non blocking
   // ioctl (s, FIONBIO, &trueval);

    // make it broadcastable
    //setsockopt(s, SOL_SOCKET, SO_BROADCAST, (char *)&trueval, sizeof(trueval));

    // set receive buffer to 64Kb
  //  j=4;
   // getsockopt(s, SOL_SOCKET, SO_RCVBUF, (char *)&i, (size_t *)&j);
    CONS_Printf("Network system receive buffer : %d\n",i);
    /*if(i<128<<10)
    {
        i=64<<10;
        if( setsockopt(s, SOL_SOCKET, SO_RCVBUF, (char *)&i, sizeof(i))!=0 )
            CONS_Printf("Can't set receive buffer length to 64k, file transfer will be bad\n");
        else
            CONS_Printf("Network system receive buffer set to : %d\n",i);
    }*/

    // ipx header
    packetheaderlength=30; // for stats

    // setup broadcast adress to BROADCASTADDR entry
	/*
#ifdef LINUX
    clientaddress[BROADCASTADDR].ipx.sipx_family = AF_IPX;
    clientaddress[BROADCASTADDR].ipx.sipx_port = htons(sock_port);
#ifndef FREEBSD
    clientaddress[BROADCASTADDR].ipx.sipx_network = 0;
    for(i=0;i<6;i++)
       clientaddress[BROADCASTADDR].ipx.sipx_node[i] = (byte)0xFF;
#else
    clientaddress[BROADCASTADDR].ipx.sipx_addr.x_net.s_net[0] = 0;
    clientaddress[BROADCASTADDR].ipx.sipx_addr.x_net.s_net[1] = 0;
    for(i=0;i<6;i++)
       clientaddress[BROADCASTADDR].ipx.sipx_addr.x_host.c_host[i] = (byte)0xFF;
#endif
#else
    clientaddress[BROADCASTADDR].ipx.sa_family = AF_IPX;
    clientaddress[BROADCASTADDR].ipx.sa_socket = htons(sock_port);
    for(i=0;i<4;i++)
       clientaddress[BROADCASTADDR].ipx.sa_netnum[i] = 0;
    for(i=0;i<6;i++)
       clientaddress[BROADCASTADDR].ipx.sa_nodenum[i] = (byte)0xFF;
#endif // linux
	   */
    SOCK_cmpaddr=BT_cmpaddr;
    return btsocket;
}
//Hurdler: temporary addition and changes for master server

static int init_tcp_driver = 0;

void I_InitTcpDriver(void)
{
    if (!init_tcp_driver)
    {
		gHelperClass = CTCPHelperClass::NewL();
        init_tcp_driver = 1;
    }
}


void SOCK_CloseSocket( void )
{
    if( mysocket.iSocketConnected )
    {
		mysocket.iSocketConnected = EFalse;
		mysocket.iSocket.Close();
    }
}

void I_ShutdownTcpDriver(void)
{
    if( mysocket.iSocketConnected )
        SOCK_CloseSocket();

    if ( init_tcp_driver )
    {
		delete gHelperClass;
		gHelperClass = NULL;
        init_tcp_driver = 0;
    }
}


int SOCK_NetMakeNode (char *hostname)
{
    int newnode;
    char *localhostname = strdup(hostname);
    char *portchar;
    int portnum = sock_port;//htons(sock_port);

    // retrieve portnum from address !
    strtok(localhostname,":");
    portchar = strtok(NULL,":");
    if( portchar )
        portnum = atoi(portchar);//htons(atoi(portchar));
    free(localhostname);

    // server address only in ip
    if(!bluetooth) // tcp/ip
    {
        char            *t;

         // remove the port in the hostname as we've it already
        t = localhostname = strdup(hostname);
        while ((*t != ':') && (*t != '\0'))
            t++;
        *t = '\0';

        newnode = getfreenode();
        if( newnode == -1 )
            return -1;
        // find ip of the server
        clientaddress[newnode].ip.SetFamily( KAfInet);//sin_family      = AF_INET;
        clientaddress[newnode].ip.SetPort(portnum);//sin_port        = portnum;
		TPtrC8 ptr((unsigned char* )localhostname, strlen(localhostname));
		HBufC* buf = HBufC::NewLC(ptr.Length());
		buf->Des().Copy(ptr);
        clientaddress[newnode].ip.Input(*buf);//sin_addr.s_addr = inet_addr(localhostname);
		CleanupStack::PopAndDestroy(buf);
        if(clientaddress[newnode].ip.Address()/*sin_addr.s_addr*/== KInetAddrNone) // not a ip ask to the dns
        {
            CONS_Printf("Resolving %s\n",localhostname);
            TInt res = gHelperClass->GetHostByName(localhostname, clientaddress[newnode].ip);//gethostbyname (localhostname);
            if (res != KErrNone)
            {
                CONS_Printf ("%s unknown\n", localhostname);
                I_NetFreeNodenum(newnode);
                free(localhostname);
                return -1;
            }
        }
		
        CONS_Printf("Resolved %s\n",SOCK_AddrToStr(&clientaddress[newnode]));
        free(localhostname);

        return newnode;
    }
	else // Do bluetooth
	{
	}

    // ipx only
    return BROADCASTADDR;
}

boolean SOCK_OpenSocket( void )
{
    int i;

	if(mysocket.iSocketConnected)
	{
		mysocket.iSocket.Close();
		mysocket.iSocketConnected = EFalse;
	}
    for(i=0;i<MAXNETNODES;i++)
        nodeconnected[i]=false;

	bluetooth = cv_bluetoothserver.value;

    nodeconnected[0] = true; // always connected to self
    nodeconnected[BROADCASTADDR] = true;
    I_NetSend        = SOCK_Send;
    I_NetGet         = SOCK_Get;
    I_NetCloseSocket = SOCK_CloseSocket;
    I_NetFreeNodenum = SOCK_FreeNodenum;


    // build the socket
    if(bluetooth) {
        mysocket = BT_Socket ();
        //net_bandwidth = 800000;
        //hardware_MAXPACKETLENGTH = MAXPACKETLENGTH;
		I_NetMakeNode    = NULL; 
    }
    else
    {
		 mysocket = UDP_Socket ();
	    I_NetMakeNode    = SOCK_NetMakeNode;


       // if (server && cv_internetserver.value)
       //     RegisterServer(mysocket, sock_port);
    }

    return mysocket.iSocketConnected;
}


boolean I_InitTcpNetwork( void )
{
    char     serverhostname[255];
    boolean  ret=0;
    
    // initilize the driver
    I_InitTcpDriver(); 
    I_AddExitFunc (I_ShutdownTcpDriver);

    if ( M_CheckParm ("-udpport") )
        sock_port = atoi(M_GetNextParm());
	
    // parse network game options,
    if ( M_CheckParm ("-server") || dedicated)
    {
        server=true;

        // if a number of clients (i.e. nodes) is specified, the server will wait for the clients to connect before starting
        // if no number is specified here, the server starts with 1 client, others can join in-game.
        // since Boris has implemented join in-game, there is no actual need for specifying a particular number here
        // FIXME: for dedicated server, numnodes needs to be set to 0 upon start
        if( M_IsNextParm() )
            doomcom->numnodes=atoi(M_GetNextParm());
        else if (dedicated)
            doomcom->numnodes=0;
        else
            doomcom->numnodes=1;

        if (doomcom->numnodes<0)
            doomcom->numnodes=0;
        if (doomcom->numnodes>MAXNETNODES)
            doomcom->numnodes=MAXNETNODES;

        // server
        servernode = 0;
        // FIXME:
        // ??? and now ?
        // server on a big modem ??? 4*isdn
        net_bandwidth = 16000;
        hardware_MAXPACKETLENGTH = INETPACKETLENGTH;

        ret = true;
    }
    else if( M_CheckParm ("-connect") )
    {
        if(M_IsNextParm())
            strcpy(serverhostname,M_GetNextParm());
        else
            serverhostname[0]=0; // assuming server in the LAN, use broadcast to detect it

        // server address only in ip
        if(serverhostname[0] && !bluetooth)
        {
            COM_BufAddText("connect \"");
            COM_BufAddText(serverhostname);
            COM_BufAddText("\"\n");

            // probably modem
            hardware_MAXPACKETLENGTH = INETPACKETLENGTH;
        }
        else
        {
            // so we're on a LAN
            COM_BufAddText("connect any\n");

            net_bandwidth = 800000;
            hardware_MAXPACKETLENGTH = MAXPACKETLENGTH;
        }
    }

    I_NetOpenSocket = SOCK_OpenSocket;

    return ret;
}


// From MServ.c

#define HEADER_SIZE ((long)sizeof(long)*3)

#define PACKET_SIZE 1024

#define  MS_NO_ERROR                   0
#define  MS_SOCKET_ERROR            -201
#define  MS_CONNECT_ERROR           -203
#define  MS_WRITE_ERROR             -210
#define  MS_READ_ERROR              -211
#define  MS_CLOSE_ERROR             -212
#define  MS_GETHOSTBYNAME_ERROR     -220
#define  MS_GETHOSTNAME_ERROR       -221
#define  MS_TIMEOUT_ERROR           -231

typedef struct {
    long    id;
    long    type;
    long    length;
    char    buffer[PACKET_SIZE];
} msg_t;

extern enum { MSCS_NONE, MSCS_WAITING, MSCS_REGISTERED, MSCS_FAILED } con_state;
TDoomSocket in_addr;

TBool gConnectedStatus = EFalse;

int MS_Connected()
{
	return gConnectedStatus?1:0;
}

class CConnectWaiter:public CActive
{
public:
	CConnectWaiter():CActive(0)
	{
		CActiveScheduler::Add(this);
		gConnectedStatus = EFalse;
	}

	~CConnectWaiter()
	{
		Cancel();
	}

	void RunL()
	{
		if(iStatus == KErrNone)
		{
			gConnectedStatus = ETrue;
		}
		delete this;
	}

	void DoCancel()
	{
	}

	void Start()
	{
		SetActive();
	}
};

void CloseConnection(void);

/*
** MS_GetIP()
*/
int MS_GetIP(char *hostname)
{
    TInetAddr address;
	TPtrC8 ptr((unsigned char* )hostname, strlen(hostname)+1);
	HBufC* buf = HBufC::NewLC(ptr.Length());
	buf->Des().Copy(ptr);
	if(address.Input(*buf) != KErrNone)
	{
        TInt res = gHelperClass->GetHostByName(hostname, address);
		if(res == KErrNone)
		{
			in_addr.iAddress = address;
		}
		else
		{
			 return MS_GETHOSTBYNAME_ERROR;
		}
	}
	CleanupStack::PopAndDestroy(buf);

    return 0;
}

char* MS_Addr()
{
	mysockaddr_t addru;
	addru.ip = in_addr.iAddress;
	return SOCK_AddrToStr(&addru);
}

void MS_CloseConnection()
{
	gConnectedStatus = EFalse;
	in_addr.iSocketConnected = EFalse;
	in_addr.iSocket.Close();
}

/*
** MS_Connect()
*/
int MS_Connect(char *ip_addr, char *str_port, int async)
{
	TInt error = KErrNone;
	in_addr.iAddress.SetFamily(KAfInet);

    I_InitTcpDriver(); // this is done only if not already done

	if((error = in_addr.iSocket.Open(gHelperClass->SockServ(), KAfInet, KSockStream, KProtocolInetTcp)) != KErrNone)
		return MS_SOCKET_ERROR;
		
    if (MS_GetIP(ip_addr)==MS_GETHOSTBYNAME_ERROR)
        return MS_GETHOSTBYNAME_ERROR;
	in_addr.iAddress.SetPort(atoi(str_port));
    if (async) // do asynchronous connection
    {
		//TInt nonBlocking = 1;
		//in_addr.iSocket.SetOpt(KSONonBlockingIO, KSOLSocket, nonBlocking);
		CConnectWaiter* waiter = new (ELeave) CConnectWaiter;
		waiter->iStatus = KRequestPending;
		in_addr.iSocket.Connect(in_addr.iAddress, waiter->iStatus);
		waiter->Start();
		//User::WaitForRequest(gStatus);
		//res = gStatus.Int();
        /*if (res < 0)
        {
            if (res  != KErrWouldBlock)
            {
                con_state = MSCS_FAILED;
                CloseConnection();
                return MS_CONNECT_ERROR;
            }
        }*/
        con_state = MSCS_WAITING;
    }
    else
    {
		TRequestStatus status = KRequestPending;
		in_addr.iSocket.Connect(in_addr.iAddress, status);
		User::WaitForRequest(status);
		TInt res = status.Int();

        if (res < 0)
            return MS_CONNECT_ERROR;
    }

    return 0;
}


/*
 * MS_Write():
 */
int MS_Write(msg_t *msg)
{
    int len;

    if (msg->length < 0)
        msg->length = strlen(msg->buffer);
    len = msg->length+HEADER_SIZE;

    //msg->id = htonl(msg->id);
    msg->type = htonl(msg->type);
    msg->length = htonl(msg->length);

	TRequestStatus status = KRequestPending;
	TPtrC8 ptr((unsigned char*) msg, len);
	in_addr.iSocket.Send(ptr,0, status);
	User::WaitForRequest(status);
	// Check actual xfer length here??
	if(status.Int() != KErrNone)
        return MS_WRITE_ERROR;

    return 0;
}


/*
 * MS_Read():
 */
int MS_Read(msg_t *msg)
{
	TRequestStatus status = KRequestPending;
	TPtr8 header((unsigned char*) msg, 0,  HEADER_SIZE);
	in_addr.iSocket.Recv(header,0, status);
	User::WaitForRequest(status);
	if(status.Int() != KErrNone || header.Length() != HEADER_SIZE)
        return MS_READ_ERROR;

    //msg->id = ntohl(msg->id);
    msg->type = ntohl(msg->type);
    msg->length = ntohl(msg->length);

    if (!msg->length) //Hurdler: fix a bug in Windows 2000
        return 0;
	status = KRequestPending;
	TPtr8 ptr((unsigned char*) msg->buffer, 0,  msg->length);
	in_addr.iSocket.Recv(ptr,0, status);
	User::WaitForRequest(status);
	if(status.Int() != KErrNone || ptr.Length() != msg->length)
        return MS_READ_ERROR;

    return 0;
}


} // end of extern "C"

